<script lang="ts">
  import { getCardValue, getSuit } from "../utils";

  import { send, receive } from "./cardCrossfade";
  import SuitIcon from "./SuitIcon.svelte";
  export let card: CardId;
  export let facedown: boolean = false;
  export let inline: boolean = false;

  $: value = getCardValue(card);
  $: suit = getSuit(card);
</script>

{#if inline}
  <span
    class="card border shadow suit-{suit} py-0.5 px-1 inline-flex items-center gap-0.5"
  >
    <span class="card-value leading-4">{value}</span>
    <span class="card-suit">
      <SuitIcon {suit} />
    </span>
  </span>
{:else}
  <div
    class="card full-size border shadow suit-{suit}"
    class:facedown
    in:receive={{ key: card }}
    out:send={{ key: card }}
  >
    {#if !facedown}
      <div class="upper">
        <div class="card-value">
          {value}
        </div>

        <div class="card-suit">
          <SuitIcon {suit} />
        </div>
      </div>

      <div class="lower">
        <div class="card-value">
          {value}
        </div>

        <div class="card-suit">
          <SuitIcon {suit} />
        </div>
      </div>
    {:else}
      <div class="inner" />
    {/if}
  </div>
{/if}

<style>
  .card {
    position: relative;

    background: radial-gradient(
      circle at center,
      hsl(35, 80%, 97%),
      hsl(35, 80%, 94%)
    );
  }

  .full-size {
    height: 7em;
    width: 5em;
  }

  .facedown .inner {
    overflow: hidden;

    border-radius: 0.15em;
    position: absolute;
    inset: 0.33em;
  }
  .facedown .inner::before {
    content: "";
    position: absolute;
    inset: -100%;
    background-color: rgb(88, 117, 38);

    background-image: linear-gradient(
        to right,
        transparent 50%,
        rgba(0, 0, 0, 0.1) 50%
      ),
      linear-gradient(to bottom, transparent 50%, rgba(0, 0, 0, 0.1) 50%);
    background-size: 0.75em 0.75em;
    background-position: center;
    transform: rotate(45deg);
  }

  .suit-a {
    color: #9b0c9b;
  }
  .suit-b {
    color: #7a5625;
  }
  .suit-c {
    color: hsl(0, 82%, 56%);
  }
  .suit-d {
    color: #2688f7;
  }
  .suit-e {
    color: #73b139;
  }
  .suit-f {
    color: #ffcc32;
  }
  .suit-f .card-value {
    -webkit-text-stroke: 1px #0004;
  }

  .card-value {
    font-weight: 900;
  }
  .full-size .card-value {
    font-size: 125%;
  }
  .card-suit {
    font-size: 75%;
  }

  .upper .card-value {
    position: absolute;
    top: 2%;
    left: 15%;
    line-height: 1;
    transform: translateX(-50%);
  }

  .upper .card-suit {
    line-height: 1;
    position: absolute;
    top: 22%;
    left: 15%;
    transform: translateX(-50%);
  }

  .lower .card-value {
    position: absolute;
    bottom: 1%;
    right: 15%;
    line-height: 1;
    transform: translateX(50%);
  }

  .lower .card-suit {
    line-height: 1;
    position: absolute;
    bottom: 21%;
    right: 15%;
    transform: translateX(50%);
  }
</style>
